"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.print = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const constants_1 = require("./constants");
function printGeneratedTS(result, options, filename) {
    const dir = path_1.default.join(options.output ?? constants_1.defaultOutputPath, constants_1.queriesOutputPath);
    if (!fs_1.default.existsSync(dir)) {
        fs_1.default.mkdirSync(dir, { recursive: true });
    }
    fs_1.default.writeFileSync(path_1.default.join(dir, filename ?? 'index.ts'), result);
}
function print(result, options, filename) {
    const outputPath = options.output ?? constants_1.defaultOutputPath;
    if (!fs_1.default.existsSync(outputPath)) {
        fs_1.default.mkdirSync(outputPath);
    }
    printGeneratedTS(result, options, filename);
}
exports.print = print;
